package provide app-sshnew 1.0 
#package require registry 
package require Suspect 
package require Expect
suspect::Import 
 
#console show

# 03/01/2008 - 1.0 - Limited Release [jhufnage]
# 04/08/2008 - 1.1 - Added versioning information to the title bar [jhufnage]
# 11/16/2009 - 1.2 - Enabled varable resolution [jhufnage]
# 12/16/2009 - 2.0 - Wrapped using TclKit/StarKit
# 05/17/2012 - 2.3 - Updated plink and added -batch command line option to plink
# 09/19/2012 - 2.4 - Updated plink to portable plink 0.62 which properly supports "-ssh <hostname>"
#					 and query WMI for DEP support
# 01/14/2013 - 2.5 - Updated to Suspect (removed expect dependencies) for Windows 8 compatability
#					 Removed DEP check since Expect is not used
# 08/30/2013 - 3.0 - Added support for MToken and additional ECAD hosts
# 12/18/2013 - 3.1 - Offically changed for new service names
# 08/16/2016 - 3.3 - Moved to standard VNCViewer. Removal of Cinnimon desktop allows dynamic resizing natively.
#					 Enabled Duo 2FA
# 09/09/2016 - 4.0 - Matched resoluton choices to VMware Horizon View Client choices
# 08/25/2017 - 4.1 - Changed behaviour to default to 2factor authentication (Duo)
# 09/06/2018 - 4.2 - Enabled Duo for our 2 remaining VNC pools

wm title . "CAEN VNC v4.2"
wm iconname . "CAENVNC"
wm resizable . 0 0

#set URL "http://caen.engin.umich.edu/connect/vnc"
set URL "http://caenfaq.engin.umich.edu/12374-Linux-Login-Service/how-do-i-connect-to-a-caen-linux-computer-remotely"
set host_list "login-course.engin.umich.edu oncampus-course.engin.umich.edu"
set v_hostname "login-course.engin.umich.edu"
set v_port 5951
#set v_username "$::env(USERNAME)"
set v_username "$::env(USER)"
set v_password ""
set v_size "Window - Large"
set v_res "800x600"
set v_token "1"
set scriptdir [file dirname [info script]]
set done 0

# Copy the executables to the users TEMP directory since Windows can't exec from VFS
#set tempdir [file join $::env(TEMP) caenvnc]
#if [file isfile $tempdir] {file delete -force $tempdir}
#file mkdir $tempdir
#file mkdir $tempdir/socat

#catch {file copy -force ${scriptdir}/plink.exe ${tempdir}/plink.exe}
#catch {file copy -force ${scriptdir}/vncviewer.exe ${tempdir}/vncviewer.exe}
#catch {file copy -force ${scriptdir}/sshhostkeys ${tempdir}/sshhostkeys}

#####################################################################
# Configure Hostname label and text box
#####################################################################
frame  .hostname -bd 2
label  .hostname.label -text Hostname: -width 12 -anchor w
ttk::combobox .hostname.combobox -textvariable v_hostname -values $host_list
pack   .hostname.label -side left
pack   .hostname.combobox  -side left
#bind   .hostname.combobox <KeyRelease> {showToken}
#bind   .hostname.combobox <<ComboboxSelected>> {showToken}

#####################################################################
# Configure default Port label and text box
#####################################################################
frame  .port -bd 2
label  .port.label -text Port: -width 12 -anchor w
entry  .port.entry -relief sunken
.port.entry config -textvariable v_port
pack   .port.label -side left
pack   .port.entry  -side left

#####################################################################
# Configure Login label and text box
#####################################################################
frame  .username -bd 2
label  .username.label -text Username: -width 12 -anchor w
entry  .username.entry -relief sunken
.username.entry config -textvariable v_username 
pack   .username.label -side left
pack   .username.entry -side left

#####################################################################
# Configure Password label and text box
#####################################################################
frame  .password -bd 2
label  .password.label -text Password: -width 12 -anchor w
entry  .password.entry -relief sunken
.password.entry config -textvariable v_password -show "*" 
pack   .password.label -side left
pack   .password.entry -side left

#####################################################################
# Configure ScreenSize label and list box
#####################################################################
frame  .screensize -bd 3
label  .screensize.reslabel -text Size: -width 12 -anchor w
ttk::combobox .screensize.combobox -state readonly -textvariable v_size -values {{All Monitors} {FullScreen} {Window - Large} {Window - Small} {Custom}}
pack   .screensize.reslabel -side left
pack   .screensize.combobox  -side left
bind   .screensize.combobox <<ComboboxSelected>> {showRes}

#####################################################################
# Configure Resolution label and list box
#####################################################################
frame  .screenres -bd 3
label  .screenres.reslabel -text "geometry:" -width 12 -anchor w
entry  .screenres.entry -relief sunken
.screenres.entry config -textvariable v_res
pack   .screenres.reslabel -side left
pack   .screenres.entry  -side left

#####################################################################
# Configure Buttons
#####################################################################
frame	.buttons -bd 2
button	.buttons.ok -text "Connect" -borderwidth 1m -command "showScreen \$v_hostname \$v_port \$v_username \$v_password \$v_token"
button	.buttons.dismiss -text "Cancel" -command "destroy ."
button	.buttons.help -text "Help" -command "exec [auto_execok start] {$URL}"
pack	.buttons.ok .buttons.dismiss .buttons.help -side left -expand 1
pack	.buttons -side bottom -fill x -pady 2m 
bind	. <Return> ".buttons.ok invoke"
bind	. <F1> ".buttons.help invoke"

####################################################################
# Configure Status label
#####################################################################
frame	.status -bd 2
label	.status.label
pack	.status.label -side left
.status.label config -text "Awaiting credentials..." 

#####################################################################
# Configure Passcode label and text box
#####################################################################
frame  .token -bd 2
label  .token.label -text "Duo Choice:" -width 12 -anchor w
entry  .token.entry -relief sunken
.token.entry config -textvariable v_token
pack   .token.label -side left
pack   .token.entry -side left

#####################################################################
# Pack everything into the window
#####################################################################
pack	.hostname .username .password .screensize .token .status .buttons -fill x

#####################################################################
# showResolution makes visible the custom resolution entry box
#####################################################################
proc showRes {} {
global v_size
	if {[string equal $v_size "Custom"]} {
		pack .screenres -after .screensize -fill x
	} else {
		pack forget .screenres
	}
}

#####################################################################
# showToken makes visible the Token and Port entry boxs
#####################################################################
#proc showToken {} {
#global v_hostname
#global v_port
#global host_list
#	if {[string equal $v_hostname "restricted-course.engin.umich.edu"]
#			|| [string equal $v_hostname "login-course-2fa.engin.umich.edu"]} {
#		pack .token -after .screensize -fill x
#		pack forget .port
#		set v_port 5951
#	} elseif {[string equal $v_hostname "oncampus-course.engin.umich.edu"]} {
#		pack forget .token
#		pack forget .port
#		set v_port 5951
#	} else {
#		pack .token -after .screensize -fill x
#		pack .port -after .hostname -fill x
#	}
#}

#####################################################################
# Focus and Raise window
#####################################################################
focus .password.entry
raise .

set wx [expr {([winfo screenwidth .]-[winfo width .])/2}]
set wy [expr {([winfo screenheight .]-[winfo height .])/2}]
wm geometry . +$wx+$wy

#####################################################################
# Let's run it...
##################################################################### 
proc showScreen {ss_host ss_port ss_user ss_pass ss_token} { 
 
global v_size 
global v_res 
global env 
global scriptdir 
global tempdir 
 
 
.buttons.ok config -state disabled 
 
# Verify files exist (AV doesn't delete) 
#if { [file exists ${tempdir}/plink.exe] == 0 } { 
#	showErr "plink.exe not found in %TEMP%" 
#	return 
#} 
#if { [file exists ${tempdir}/vncviewer.exe] == 0 } { 
#	showErr "vncviewer.exe not found in %TEMP%" 
#	return 
#} 
#if { [file exists $::env(WINDIR)/SYSTEM32/netstat.exe] == 0 } { 
#	showErr "netstat.exe not found in $::env(WINDIR)/SYSTEM32" 
#	return 
#} 
if { ![regexp {^[1-9]\d+x[1-9]\d+$} $v_res]} { 
	showErr "Error: geometry bad format" 
	set v_res "800x600" 
	return 
} 
 
set v_fs "" 
set v_all "FullScreenAllMonitors=0" 
if {$v_size == "All Monitors"} { 
	set v_res [format %s%s%s [expr {int(1.00 * [winfo screenwidth .])}] "x" [expr {int(1.00 * [winfo screenheight .])}]] 
	set v_fs "FullScreen=1" 
	set v_all "FullScreenAllMonitors=1" 
} 
if {$v_size == "FullScreen"} { 
	set v_res [format %s%s%s [expr {int(1.00 * [winfo screenwidth .])}] "x" [expr {int(1.00 * [winfo screenheight .])}]] 
	set v_fs "FullScreen=1" 
} 
if {$v_size == "Window - Large"} { 
	set v_res [format %s%s%s [expr {int(0.90 * [winfo screenwidth .])}] "x" [expr {int(0.90 * [winfo screenheight .])}]] 
} 
if {$v_size == "Window - Small"} { 
	set v_res [format %s%s%s [expr {int(0.50 * [winfo screenwidth .])}] "x" [expr {int(0.50 * [winfo screenheight .])}]] 
} 
 
set env(CAENVNCSIZE) $v_res 
 
set lport   [expr {$ss_port + 10000}] 
 
# Localport (lport) needs to be free. 
# Run netstat and increment through ports until free port found 
set nsr [exec "netstat" -an] 
while {[lsearch -regexp $nsr $lport] != -1} { set lport [expr {$lport + 1}] } 
 
# Show the user we're contacting the host 
.status.label config -text "" 
.status.label config -text [string range "Contacting $ss_host" 0 35] 
 
# Spawn and open a channel to plink 
#set channel [Spawn ${tempdir}/plink.exe -L $lport:localhost:$ss_port -ssh $ss_host -C "echo hello\;cat" 2>@1]
#set channel [Spawn ssh -L $lport:localhost:$ss_port  $ss_user@$ss_host "echo hello;cat" 2>@1]
exp_spawn ssh -L $lport:localhost:$ss_port $ss_user@$ss_host "echo hello\;cat"
 
#set pid [CVar $channel pid]  
 
# Plink won't output errors to stdout so we have to work around 'hostname not found' and 'bad password' errors 
set pwcount 0 
set done 0 
#while { $done == 0 } { 
#Expect $channel -regexp -onEOF showEOF -timeout 30 -onTIMEOUT showTimeout {  
#		"hostname"				{showErr "Hostname not found!"; set done 1} 
#                "Are you sure*"         {Send $channel  "yes\r"}
#		"login as:"			{Send $channel "$ss_user \r"} 
#		"Password:" 		{Send $channel "$ss_pass \r"; set pwcount [expr {$pwcount + 1}]} 
#		"password:" 		{Send $channel "$ss_pass \r"; set pwcount [expr {$pwcount + 1}]} 
#		"Passcode" 			{Send $channel "$ss_token \r"} 
#		"passcode" 			{Send $channel "$ss_token \r"} 
#		"hello"  			{wm withdraw .;exec $::env(COTVNCDIR)/vncviewer $v_all $v_fs geometry=$v_res localhost:$lport 2>@1; Close $channel; destroy .} 
#		} 
#	if { $pwcount > 1 } {showErr "Access denied!"; set done 1} 
#} 
#Close $channel 
while { $done == 0 } {

expect {
         "Are you sure*"         {exp_send "yes\r"}
         "MToken*"      {exp_send  "$ss_token\r"}
         "Passcode"         {exp_send "$ss_token\r"}
         "passcode"         {exp_send "$ss_token\r"}
         "Password*"              {exp_send "$ss_pass\r";set pwcount [expr {$pwcount + 1}]}
         "password*"              {exp_send "$ss_pass\r";set pwcount [expr {$pwcount + 1}]}
         "You are not auth"      {showErr "You are not authorized to use this service."; set done 1}
         "hello*"                {wm withdraw .;exec  $::env(COTVNCDIR)/vncviewer $v_all $v_fs geometry=$v_res localhost:$lport 2>@1;  destroy .;exp_close;exit} 
       }
 if { $pwcount > 1 } {showErr "Access denied!"; set done 1}
}


.buttons.ok config -state normal 
} 
#DesktopSize=$v_res 
##################################################################### 
# Error conditions (Expect errors can't have arguments 
##################################################################### 
proc showErr {str_message} { 
	.status.label config -text $str_message 
	.buttons.ok config -state normal 
} 
proc showEOF {} { 
	.status.label config -text "Unexpected Error!" 
	.buttons.ok config -state normal 
} 
proc showTimeout {} { 
	.status.label config -text "Timeout!" 
	.buttons.ok config -state normal 
} 
